/* gte.c */

#define	VX0	((short*)r)[0*2]
#define	VY0	((short*)r)[0*2+1]
#define	VZ0	((short*)r)[1*2]
#define	VX1	((short*)r)[2*2]
#define	VY1	((short*)r)[2*2+1]
#define	VZ1	((short*)r)[3*2]
#define	VX2	((short*)r)[4*2]
#define	VY2	((short*)r)[4*2+1]
#define	VZ2	((short*)r)[5*2]
#define	RGB	r[6]
#define	OTZ	((short*)r)[7*2]
#define	IR0	r[8]
#define	IR1	r[9]
#define	IR2	r[10]
#define	IR3	r[11]
#define	SX0	((short*)r)[12*2]
#define	SY0	((short*)r)[12*2+1]
#define	SX1	((short*)r)[13*2]
#define	SY1	((short*)r)[13*2+1]
#define	SX2	((short*)r)[14*2]
#define	SY2	((short*)r)[14*2+1]
#define	SXP	((short*)r)[15*2]
#define	SYP	((short*)r)[15*2+1]
#define	SZ0	r[16]
#define	SZ1	r[17]
#define	SZ2	r[18]
#define	SZx	r[19]
#define	RGB0	r[20]
#define	RGB1	r[21]
#define	RGB2	r[22]
#define	MAC0	r[24]
#define	MAC1	r[25]
#define	MAC2	r[26]
#define	MAC3	r[27]
#define	IRGB	r[28]
#define	ORGB	r[29]
#define	LZCS	r[30]
#define	LZCR	r[31]

#define	R11	((short*)r)[(0+32)*2]
#define	R12	((short*)r)[(0+32)*2+1]
#define	R13	((short*)r)[(1+32)*2]
#define	R21	((short*)r)[(1+32)*2+1]
#define	R22	((short*)r)[(2+32)*2]
#define	R23	((short*)r)[(2+32)*2+1]
#define	R31	((short*)r)[(3+32)*2]
#define	R32	((short*)r)[(3+32)*2+1]
#define	R33	((short*)r)[(4+32)*2]
#define	TRX	r[5+32]
#define	TRY	r[6+32]
#define	TRZ	r[7+32]
#define	L11	((short*)r)[(8+32)*2]
#define	L12	((short*)r)[(8+32)*2+1]
#define	L13	((short*)r)[(9+32)*2]
#define	L21	((short*)r)[(9+32)*2+1]
#define	L22	((short*)r)[(10+32)*2]
#define	L23	((short*)r)[(10+32)*2+1]
#define	L31	((short*)r)[(11+32)*2]
#define	L32	((short*)r)[(11+32)*2+1]
#define	L33	((short*)r)[(12+32)*2]
#define	RBK	r[13+32]
#define	GBK	r[14+32]
#define	BBK	r[15+32]
#define	LR1	((short*)r)[(16+32)*2]
#define	LR2	((short*)r)[(16+32)*2+1]
#define	LR3	((short*)r)[(17+32)*2]
#define	LG1	((short*)r)[(17+32)*2+1]
#define	LG2	((short*)r)[(18+32)*2]
#define	LG3	((short*)r)[(18+32)*2+1]
#define	LB1	((short*)r)[(19+32)*2]
#define	LB2	((short*)r)[(19+32)*2+1]
#define	LB3	((short*)r)[(20+32)*2]
#define	RFC	r[21+32]
#define	GFC	r[22+32]
#define	BFC	r[23+32]
#define	OFX	(r[24+32]>>16)
#define	OFY	(r[25+32]>>16)
#define	H	((short*)r)[(26+32)*2]
#define	DQA	((short*)r)[(27+32)*2]
#define	DQB	r[28+32]
#define	ZSF3	((short*)r)[(29+32)*2]
#define	ZSF4	((short*)r)[(30+32)*2]
#define	FLAG	r[31+32]

#define	FIX(a)	((a)>>12)

#define	LIMIT(a,min,max)	if (a<min) a=min; else if (a>max) a=max

/* (a<min)?min:(a>max)?max:a */

static void cop2_198003d(int *r)
{
	/* GPF? */
	IR1 = FIX(IR1 * IR0);
	IR2 = FIX(IR2 * IR0);
	IR3 = FIX(IR3 * IR0);
}

static void cop2_0486012(int *r)
{
	/* MVMVA? */
	int t;
	t = MAC1 = FIX(R11*VX0+R12*VY0+R13*VZ0);
	LIMIT(t,-32768,32767);
	IR1 = t;
	t = MAC2 = FIX(R21*VX0+R22*VY0+R23*VZ0);
	LIMIT(t,-32768,32767);
	IR2 = t;
	t = MAC3 = FIX(R31*VX0+R32*VY0+R33*VZ0);
	LIMIT(t,-32768,32767);
	IR3 = t;
}

static void cop2_041e012(int *r)
{
}

static void cop2_0180001(int *r)
{
	/* RTPS */
	int vx,vy,vz,rz;
	SZx = SZ0;
	SZ0 = SZ1;
	SZ1 = SZ2;
	vx = FIX(R11*VX0+R12*VY0+R13*VZ0)+TRX;
	vy = FIX(R21*VX0+R22*VY0+R23*VZ0)+TRY;
	vz = FIX(R31*VX0+R32*VY0+R33*VZ0)+TRZ;
	LIMIT(vz,0,65535);
	rz = H*4096/vz;
	SX2 = FIX(vx*rz)+OFX;
	SY2 = FIX(vy*rz)+OFY;
	SZ2 = vz;
}

static void cop2_0280030(int *r)
{
	/* RTPT */
	int vx,vy,vz,rz;
	SZx = SZ2;
	vx = FIX(R11*VX0+R12*VY0+R13*VZ0)+TRX;
	vy = FIX(R21*VX0+R22*VY0+R23*VZ0)+TRY;
	vz = FIX(R31*VX0+R32*VY0+R33*VZ0)+TRZ;
	LIMIT(vz,0,65535);
	rz = H*4096/vz;
	SX0 = FIX(vx*rz)+OFX;
	SY0 = FIX(vy*rz)+OFY;
	SZ0 = vz;
	vx = FIX(R11*VX1+R12*VY1+R13*VZ1)+TRX;
	vy = FIX(R21*VX1+R22*VY1+R23*VZ1)+TRY;
	vz = FIX(R31*VX1+R32*VY1+R33*VZ1)+TRZ;
	LIMIT(vz,0,65535);
	rz = H*4096/vz;
	SX1 = FIX(vx*rz)+OFX;
	SY1 = FIX(vy*rz)+OFY;
	SZ1 = vz;
	vx = FIX(R11*VX2+R12*VY2+R13*VZ2)+TRX;
	vy = FIX(R21*VX2+R22*VY2+R23*VZ2)+TRY;
	vz = FIX(R31*VX2+R32*VY2+R33*VZ2)+TRZ;
	LIMIT(vz,0,65535);
	rz = H*4096/vz;
	SX2 = FIX(vx*rz)+OFX;
	SY2 = FIX(vy*rz)+OFY;
	SZ2 = vz;
}

static void cop2_1400006(int *r)
{
	/* NCLIP */
	MAC0 = SX0*(SY1-SY2)+SX1*(SY2-SY0)+SX2*(SY0-SY1);
}

static void cop2_158002d(int *r)
{
	/* AVSZ3 */
	// OTZ = (SZ0 + SZ1 + SZ2)/(3*4);
	OTZ = FIX((SZ0 + SZ1 + SZ2)*ZSF3);
}

static void cop2_158002e(int *r)
{
	/* AVSZ4 */
	// OTZ = (SZ0 + SZ1 + SZ2 + SZx)/(4*4);
	OTZ = FIX((SZ0 + SZ1 + SZ2 + SZx)*ZSF4);
}

static void cop2_0a80428(int *r)
{
	/* SQR? */
	MAC1 = IR1*IR1;
	MAC2 = IR2*IR2;
	MAC3 = IR3*IR3;
}

int cop2(int code,int *r)
{
	switch(code){
	case 0x0180001:	cop2_0180001(r); break;
	case 0x0280030:	cop2_0280030(r); break;
	case 0x0486012:	cop2_0486012(r); break;
	case 0x0a80428:	cop2_0a80428(r); break;
	case 0x1400006:	cop2_1400006(r); break;
	case 0x158002d:	cop2_158002d(r); break;
	case 0x158002e:	cop2_158002e(r); break;
	case 0x198003d:	cop2_198003d(r); break;
	default:
		printf("unsupport cop2:%x\n",code);
		return -1;
	}
	return 0;
}